class FileOps : GLib.Object
{
    public static GLib.KeyFile? presets = null;

    public static void load_presets () throws GLib.Error
    {
        presets = new GLib.KeyFile ();
        var file = GLib.File.new_for_path (presets_path);
        if (file.query_exists())
        {
        //    try
        //    {
                presets.load_from_file(presets_path, GLib.KeyFileFlags.NONE);
        //    } catch (Error e) { stderr.printf ("%s\n", e.message);
        //    }
        }
    }

    public static void write_presets_to_disk () throws GLib.Error
    {
        if ( presets == null )
        {
            stderr.printf("Error: No preset to write..");
            return;
        }
        var data = presets.to_data();
        //try
        //{
            var file = GLib.File.new_for_path (presets_path);
            if (file.query_exists()) file.delete();
            var dos = new GLib.DataOutputStream(file.create (GLib.FileCreateFlags.REPLACE_DESTINATION));
                dos.put_string (data);
            //stderr.printf ("preset file saved to disk..\n");
            update_quicklist ();
        //} catch (Error e) {
        //    stderr.printf ("%s\n", e.message);
        //}
    }

    public static void delete_preset (string preset, bool write_to_disk=true) throws GLib.Error
    {
        load_presets ();
        //try
        //{
            presets.remove_group (preset);
            stderr.printf (@"preset `$preset' deleted..\n");
        //} catch (Error e) {
        //    stderr.printf ("%s\n", e.message);
        //}
        if (write_to_disk)
            write_presets_to_disk ();
    }

    public static void check_config_dir () throws GLib.Error
    {
        var file = GLib.File.new_for_path (sgt_home_dir);
        if (! file.query_exists ())
        {
//            try {
            file.make_directory();
//            } catch (Error e) {
//                stdout.printf("Error while creating config directory:\n%s", e.message);
//            }
        }
    }

    public static void update_quicklist () throws GLib.Error
    {
        string launcher= "";
        string groups = "";
        GLib.FileUtils.get_contents (@"$DATADIR/sgtimer.desktop", out launcher);
        unowned GLib.KeyFile? pf = FileOps.presets;
        var presets = pf.get_groups ();
        launcher += "\nX-Ayatana-Desktop-Shortcuts=";
        foreach (var p in presets)
        {
            if (p[0].to_string() == "_")
            {
                launcher += "%s;".printf(p[1:p.length]);
                groups += "

[%s Shortcut Group]
Name=%s
Exec=env UBUNTU_MENUPROXY= sgtimer '%s'
".printf(p[1:p.length],p[1:p.length],p[1:p.length]);

            }

        }
        launcher += groups;
        var path = "%s/.local/share/applications".printf(GLib.Environment.get_variable("HOME"));
        var dir = GLib.File.new_for_path (path);
        if (! dir.query_exists ()) {
            dir.make_directory();
        }
        GLib.FileUtils.set_contents( @"$path/sgtimer.desktop", launcher);
    }

    public static void update_survive_launcher (bool create) throws GLib.Error
    {
        var path = "%s/.config/autostart".printf (GLib.Environment.get_variable("HOME"));
        var dir = GLib.File.new_for_path (path);
        if (! dir.query_exists ()) {
            dir.make_directory();
        }
        var file = @"$path/sgtimer-survive.desktop";
        if (create) {
            string launcher = "[Desktop Entry]
Type=Application
Name=SGTimer
Exec=env UBUNTU_MENUPROXY= sgtimer timer_survive_reboot
X-GNOME-Autostart-enabled=true
Hidden=false
NoDisplay=false";
            GLib.FileUtils.set_contents (file, launcher);
        }
        else {
            GLib.FileUtils.remove (file);
        }

    }
}