
// Modul interface
public interface ModulIF : GLib.Object
{
    public abstract signal void     action_trigger       ();
    public abstract signal void     start_default_action ();
    public abstract signal void     update_widget (string wtime);
    public abstract signal void     save_preset_trigger  (string? str);

    public abstract bool            widget_exists     {get;set;}
    public abstract bool            running           {get;set;}
    public abstract string          get_name          ();
    public abstract Gtk.Grid        get_ui            ();
    public abstract void            set_focus         ();
    public abstract bool            start             ();
    public abstract bool            stop              ();
    public abstract bool            stop_refresh      ();
    public abstract bool            start_refresh     ();
    public abstract void            set_lock_input    (bool lock);
    public abstract void            init_widget       ();
    public abstract void            load_preset       (string preset_name) throws GLib.KeyFileError;
    public abstract void            save_preset       (string preset_name) throws GLib.KeyFileError;
    public abstract Gtk.MenuItem[]  get_file_menu     ();
    public abstract Gtk.CheckMenuItem[]  get_settings_menu ();
}

// Extras interface
public interface ExtIF : GLib.Object
{
    public abstract signal void     notify_send   (string title, string body);
    public abstract string          name          {get;set;}
    public abstract Gtk.Grid        get_ui        ();
    public abstract void            save_preset   (string preset_name) throws GLib.KeyFileError;
    public abstract void            load_preset   (string preset_name) throws GLib.KeyFileError;
    public abstract bool            execute       (bool sync);
}