class Timer : GLib.Object, ModulIF
{
    public Gtk.Grid ui;
    public Gtk.EventBox days_box;
    public bool running { get; set; default = false;}
    public bool widget_exists { get; set; default = false;}
    private string cz_num = "+ěščřžýáíé";
    private string num    = "1234567890";
    private bool charcheck_working = false;
    private bool updating_time_view = false;
    private bool special_input = false;
    private GLib.TimeSpan remaining_time;
    private GLib.TimeSpan remaining_time_before_start;
    private Gtk.SpinButton entry;
    private Gtk.Label days;
    private Gtk.Label hours;
    private Gtk.Label minutes;
    private Gtk.Label seconds;
    private Gtk.Label end_day;
    private Gtk.Label end_hour;
    private Gtk.Label end_minute;
    private GLib.DateTime target_time;
    private GLib.TimeSpan limit = 604800000000;
    private uint refresh_timeout;
    public Gtk.MenuItem[]? file_menu = null;
    public Gtk.CheckMenuItem[]? settings_menu = null;
    private int preset_format = Timer_Preset.DURATION;
    private bool lock_input = false;

    public Timer ()
    {
        remaining_time = GLib.TimeSpan.HOUR;
    }

    public string get_name ()
    {
        return "Timer";
    }

    public Gtk.Grid get_ui ()
    {
        if (ui == null) build_ui();
        return ui;
    }

    public void set_focus ()
    {
        this.entry.grab_focus();
    }

    public void build_ui()
    {
        
        days_box = new Gtk.EventBox();
            days_box.set_visible_window (false);

        var days_lbl = new Gtk.Label("");
            days_lbl.set_markup (Markup.small ("D"));
            days_lbl.set_tooltip_text (_("Days"));

        days = new Gtk.Label ("");
        days_box.add (days);
        days_box.add_events (Gdk.EventMask.SCROLL_MASK);
        days_box.scroll_event.connect ((e)=>
                {on_time_scrolled (e, GLib.TimeSpan.DAY); return true;});
        days_box.button_press_event.connect ((e)=>
                {on_time_clicked  (e, GLib.TimeSpan.DAY); return true;});


        var time_lbl = new Gtk.Label ("");
            time_lbl.set_markup (Markup.small (_("H : M : S")));
            time_lbl.set_tooltip_text (_("Hours : Minutes : Seconds"));

        var hours_box = new Gtk.EventBox();
            hours_box.set_visible_window (false);

        hours = new Gtk.Label ("");
        hours_box.add (hours);
        hours_box.add_events (Gdk.EventMask.SCROLL_MASK);
        hours_box.scroll_event.connect ((e)=>
                {on_time_scrolled (e, GLib.TimeSpan.HOUR); return true;});
        hours_box.button_press_event.connect ((e)=>
                {on_time_clicked  (e, GLib.TimeSpan.HOUR); return true;});

        var col1 = new Gtk.Label ("");

        var minutes_box = new Gtk.EventBox();
            minutes_box.set_visible_window (false);
        minutes = new Gtk.Label ("");
        minutes_box.add (minutes);
        minutes_box.add_events (Gdk.EventMask.SCROLL_MASK);
        minutes_box.scroll_event.connect ((e)=>
                {on_time_scrolled (e, GLib.TimeSpan.MINUTE); return true;});
        minutes_box.button_press_event.connect ((e)=>
                {on_time_clicked  (e, GLib.TimeSpan.MINUTE); return true;});

        var col2 = new Gtk.Label ("");

        var seconds_box = new Gtk.EventBox();
            seconds_box.set_visible_window (false);
        seconds = new Gtk.Label ("");
        seconds_box.add (seconds);
        seconds_box.add_events (Gdk.EventMask.SCROLL_MASK);
        seconds_box.scroll_event.connect ((e)=>
                {on_time_scrolled (e, GLib.TimeSpan.SECOND); return true;});
        seconds_box.button_press_event.connect ((e)=>
                {on_time_clicked  (e, GLib.TimeSpan.SECOND); return true;});

        var entry_lbl = new Gtk.Label.with_mnemonic ("");
            entry_lbl.set_markup_with_mnemonic (Markup.small ("_Minutes:"));
        entry = new Gtk.SpinButton.with_range(0, 10080, 1);
        entry.set_max_length (8);
        entry.xalign    = 0.5f;
        entry.numeric   = false;
        entry.changed.connect ( ()=> {charcheck (entry);});
        entry.scroll_event.connect ((e)=> { on_time_scrolled (e, GLib.TimeSpan.MINUTE);
                                            return true; });
        entry.activate.connect (on_entry_activated);
        entry.set_tooltip_text (_("h:m - to set target time\n-h:m - to set timer\nYou can use either , or . instead of colon"));

        entry_lbl.mnemonic_widget = entry;

        var end_time_lbl = new Gtk.Label ("");
            end_time_lbl.set_markup (Markup.small ("Target time:"));

        var end_day_box = new Gtk.EventBox();
        end_day_box.set_visible_window (false);
        end_day = new Gtk.Label ("");
        end_day_box.add (end_day);
        end_day_box.add_events (Gdk.EventMask.SCROLL_MASK);
        end_day_box.scroll_event.connect ((e)=>
                {on_time_scrolled (e, GLib.TimeSpan.DAY, true); return true;});
        end_day_box.button_press_event.connect ((e)=>
                {on_time_clicked  (e, GLib.TimeSpan.DAY, true); return true;});


        var end_hour_box = new Gtk.EventBox();
        end_hour_box.set_visible_window (false);
        end_hour = new Gtk.Label ("");
        end_hour_box.add (end_hour);
        end_hour_box.add_events (Gdk.EventMask.SCROLL_MASK);
        end_hour_box.scroll_event.connect ((e)=>
                {on_time_scrolled (e, GLib.TimeSpan.HOUR, true); return true;});
        end_hour_box.button_press_event.connect ((e)=>
                {on_time_clicked  (e, GLib.TimeSpan.HOUR, true); return true;});

        var col3 = new Gtk.Label ("");

        var end_minute_box = new Gtk.EventBox();
        end_minute_box.set_visible_window (false);
        end_minute = new Gtk.Label ("");
        end_minute_box.add (end_minute);
        end_minute_box.add_events (Gdk.EventMask.SCROLL_MASK);
        end_minute_box.scroll_event.connect ((e)=>
                {on_time_scrolled (e, GLib.TimeSpan.MINUTE, true); return true;});
        end_minute_box.button_press_event.connect ((e)=>
                {on_time_clicked  (e, GLib.TimeSpan.MINUTE, true); return true;});


        ui = new Gtk.Grid ();
        ui.column_spacing     = 2;
        ui.row_spacing        = 4;
        ui.column_homogeneous = true;
        ui.set_tooltip_text (_("You can adjust each item\nby rotating mouse wheel or\nby pressing left/right mouse buttons"));

        ui.attach ( days_lbl,       0, 0,  4, 1 );
        ui.attach ( time_lbl,       5, 0, 11, 1 );
        ui.attach ( entry_lbl,     17, 0, 20, 1 );
        ui.attach ( end_time_lbl,  36, 0, 14, 1 );

        ui.attach ( days_box,       0, 1,  4, 1 );
        ui.attach ( hours_box,      5, 1,  3, 1 );
        ui.attach ( col1,           8, 1,  1, 1 );
        ui.attach ( minutes_box,    9, 1,  3, 1 ); 
        ui.attach ( col2,          12, 1,  1, 1 );
        ui.attach ( seconds_box,   13, 1,  3, 1 );
        ui.attach ( entry,         19, 1, 16, 1 );
        ui.attach ( end_day_box,   36, 1,  6, 1 );
        ui.attach ( end_hour_box,  42, 1,  3, 1 );
        ui.attach ( col3,          45, 1,  1, 1 );
        ui.attach ( end_minute_box,46, 1,  3, 1 );

        col1.set_markup       ( Markup.bbig ( ":"  ) );
        col2.set_markup       ( Markup.bbig ( ":"  ) );
      
        end_day.set_markup    (  Markup.big ( "Thu") );
        col3.set_markup       (  Markup.big ( ":"  ) );

        update_time_view();
        update_entry ();
        ui.show_all();
        start_refresh();
    }

    private void on_time_scrolled (Gdk.EventScroll e, int64 step, bool target_t = false)
    {
        change_time_by_mouse (e.direction, step, target_t);
    }

    private void on_time_clicked (Gdk.EventButton e, int64 step, bool target_t = false)
    {
        Gdk.ScrollDirection dir;
        if (e.button == 1) dir = Gdk.ScrollDirection.UP;
        else if (e.button == 3) dir = Gdk.ScrollDirection.DOWN;
        else return;
        change_time_by_mouse(dir, step, target_t);
    }

    private void change_time_by_mouse (Gdk.ScrollDirection dir, int64 step, bool target_t)
    {
        if (lock_input) return;
        int64 offset = 0;
        if (target_t) // if target time adjusted, remaining_time is calculated precisely to the minute
        {
            offset = GLib.TimeSpan.MINUTE- new GLib.DateTime.now_local().get_second()*GLib.TimeSpan.SECOND;
            remaining_time -= remaining_time % GLib.TimeSpan.MINUTE;
        }
        if (dir == Gdk.ScrollDirection.UP){
                remaining_time += step+offset;
                if (remaining_time > limit) remaining_time -= step;
        }
        else { remaining_time -= step-offset;
               if (remaining_time < 0) remaining_time += step;
        }
        update_entry ();
        update_time_view ();
    }

    private void update_entry ()
    {
        updating_time_view = true; //block update time from entry field
        entry.set_text (("%"+int64.FORMAT).printf(remaining_time/GLib.TimeSpan.MINUTE));
        updating_time_view = false;
    }

    private void update_time_view ()
    {
        special_input = false;
        if (remaining_time < 0)
            remaining_time = remaining_time.abs();
        var ds =  remaining_time / GLib.TimeSpan.DAY;
        var hs = (remaining_time / GLib.TimeSpan.HOUR  ) % 24;
        var ms = (remaining_time / GLib.TimeSpan.MINUTE) % 60;
        var ss = (remaining_time / GLib.TimeSpan.SECOND) % 60;

        days.set_markup    (Markup.bbig(("%"+int64.FORMAT).printf  (ds)));
        hours.set_markup   (Markup.bbig(("%02"+int64.FORMAT).printf(hs)));
        minutes.set_markup (Markup.bbig(("%02"+int64.FORMAT).printf(ms)));
        seconds.set_markup (Markup.bbig(("%02"+int64.FORMAT).printf(ss)));
//        if (widget_exists)
//        {
            string label;
            if (ds == 0)
                label = ("%"+int64.FORMAT+":%02"+int64.FORMAT+":%02"+int64.FORMAT).printf(hs,ms,ss);
            else
                label = ("%"+int64.FORMAT+"d %"+int64.FORMAT+":%02"+int64.FORMAT+":%02"+int64.FORMAT).printf(ds,hs,ms,ss);
            update_widget (label);
//        }
        update_end_time();
    }

    private void update_end_time ()
    {
        target_time = new GLib.DateTime.now_local().add (remaining_time);
        end_day.set_markup    (Markup.big("%s".printf(target_time.format("%a"))));
        end_hour.set_markup   (Markup.big("%02d".printf(target_time.get_hour())));
        end_minute.set_markup (Markup.big("%02d".printf(target_time.get_minute())));
    }

    private void update_remaining_time_from_entry ()
    {
        var t = int64.parse (entry.get_text());
        var rt = t*GLib.TimeSpan.MINUTE;
        if (rt <= limit) {
            remaining_time = rt;
        }
        else update_entry ();
    }

    public void init_widget ()
    {
        update_time_view ();
    }

    private void on_entry_activated ()
    {
        var t = entry.get_text();
        if (t == "")
            entry.set_text ("0");

        else if (special_input)
        {
            special_input = false;
            string[] tt = {"0","0"};

            bool duration = false;
            if (t[0].to_string() == "-") {
                t = t[1:t.length];
                duration = true;
            }
            if (":" in t) {
                tt = t.split(":"); }
            else if ("," in t) {
                tt = t.split(","); }
            else if ("." in t) {
                tt = t.split("."); }
            else tt = {t,"0"};
    
            var hr = int.parse (tt[0]);
            var mt = int.parse (tt[1]);
    
            if (duration)
                remaining_time = (hr*GLib.TimeSpan.HOUR + mt*GLib.TimeSpan.MINUTE);
            else
            {
                var now = new GLib.DateTime.now_local();
                var r = hr*60+mt;
                var a = now.get_hour()*60+now.get_minute();
                remaining_time = (r-a+1440)%1440*GLib.TimeSpan.MINUTE-now.get_second()*GLib.TimeSpan.SECOND;
            }
            update_entry ();
            update_time_view();
            update_end_time();
            set_focus();
            special_input = false;
        }
        else start_default_action ();
    }

    private void charcheck (Gtk.Entry entry)
    {

        if (updating_time_view) return;
        charcheck_working = true;
        //var text  = entry.get_text();
        var pos   = entry.get_position();
        var ch    = entry.get_chars (pos, pos+1);
        var pos1  = entry.get_chars (0, 1);
        if (ch != "")
        {
            if (((pos != 0) && (ch in ":.,")) || pos1 == "-")
            {
                special_input = true;
                charcheck_working = false;
                return;
            }
            else if (!((ch in cz_num) || (ch in num)))
            {
                entry.select_region (pos, pos+1);
                entry.delete_selection ();
            }
            else if (ch in cz_num)
            {
                var c = cz_num.index_of(ch);
                if (c > 0) c++; // string.index_of() counts bytes not chars
                entry.select_region (pos, pos+1);
                entry.delete_selection ();
                entry.insert_text (num [c/2].to_string(), -1, ref pos);
            }
        }

        if (! special_input)
        {
            stderr.printf (entry.get_text());
            update_remaining_time_from_entry();
            update_time_view();
        }        
        charcheck_working = false;
    }

    private bool countdown ()
    {
        if (running)
        {
            remaining_time = target_time.difference(new GLib.DateTime.now_local());

            if (remaining_time < GLib.TimeSpan.SECOND)
            {
                stop ();
                remaining_time = remaining_time_before_start;
                update_time_view ();
                action_trigger();
                return running;
            }
            update_time_view();
        }
        return running;

    }

    private bool refresh ()
    {
        if (running) return false;
        update_end_time();
        return true;
    }

    public bool start ()
    {
        running = true;
        remaining_time_before_start = remaining_time;
        // Timeout first call of countdown is made immediately so one sec needs to be added
        remaining_time -= remaining_time % GLib.TimeSpan.SECOND - GLib.TimeSpan.SECOND; // yes result is (-microsecs+1sec)
        update_end_time ();
        GLib.Timeout.add (1000, countdown);
        if (settings_menu[Timer_Settings.SURVIVE].get_active())
        {
            update_survive_launcher (true);
        }
        return true;
    }

    private void update_survive_launcher (bool create)
    {
        if (! running) return;
        try {
            preset_format = Timer_Preset.TARGET_TIME_DAY;
            save_preset_trigger ("timer_survive_reboot");
            FileOps.update_survive_launcher (create);
        } catch (Error e) {
            stderr.printf("Timer: Error while creating launcher for 'survive reboot' option:\n%s",
                e.message);
        }
    }

    public bool stop ()
    {
        running = false;
        update_time_view();
        start_refresh ();
        try {
            FileOps.update_survive_launcher (false);
        } catch (Error e) {
                stderr.printf("Timer: Error while deleting launcher for 'survive reboot' option:\n%s",
                    e.message);
        }
        return true;
    }

    public bool start_refresh ()
    {
        refresh ();
        refresh_timeout = GLib.Timeout.add(1000, refresh);
        return true;
    }

    public bool stop_refresh ()
    {
        GLib.Source.remove (refresh_timeout);
        return true;
    }
    
    public void set_lock_input (bool lock)
    {
        lock_input = lock;
        if (lock_input) entry.set_sensitive (false);
        else entry.set_sensitive (true);
    }

    public void save_preset (string preset_name) throws GLib.KeyFileError
    {
        unowned GLib.KeyFile? presets = FileOps.presets;
        switch (preset_format)
        {
            case Timer_Preset.DURATION:
            {
                // save time in seconds
                presets.set_int64 (preset_name, "timer", (remaining_time/GLib.TimeSpan.SECOND));
                break;
            }
            case Timer_Preset.TARGET_TIME:
            {
                var h = target_time.get_hour();
                var m = target_time.get_minute();
                presets.set_integer_list (preset_name, "timer", {h,m});
                break;
            }
            case Timer_Preset.TARGET_TIME_DAY:
            {
                var d = target_time.get_day_of_week();
                var h = target_time.get_hour();
                var m = target_time.get_minute();
                presets.set_integer_list (preset_name, "timer", {d,h,m});
                break;
            }
        }
        presets.set_boolean (preset_name, "survive_reboot", settings_menu[Timer_Settings.SURVIVE].get_active());
    }

    public void load_preset (string preset_name) throws GLib.KeyFileError
    {
        unowned GLib.KeyFile? presets = FileOps.presets;
        if (presets.has_key ( preset_name, "timer"))
        {
            var t = presets.get_integer_list ( preset_name, "timer");
            switch (t.length)
            {
                case 1:
                {
                    remaining_time = presets.get_int64 ( preset_name, "timer")*GLib.TimeSpan.SECOND;
                    break;
                }
                case 2:
                {
                    var now = new GLib.DateTime.now_local();
                    var tt = t[0]*60+t[1];
                    var at = now.get_hour()*60+now.get_minute();
                    remaining_time = (tt-at+1440)%1440*GLib.TimeSpan.MINUTE-now.get_second()*GLib.TimeSpan.SECOND;
                    break;
                }
                case 3:
                {
                    var now = new GLib.DateTime.now_local();
                    var tt = (t[0]*1440)+(t[1]*60)+t[2];
                    var at = (now.get_day_of_week()*1440)+(now.get_hour()*60)+now.get_minute();
                    remaining_time = (tt-at+10080)%10080*GLib.TimeSpan.MINUTE-now.get_second()*GLib.TimeSpan.SECOND;
                    break;
                }
            }
            update_time_view ();
            update_entry();
        }
        if (presets.has_key ( preset_name, "survive_reboot"))
            settings_menu[Timer_Settings.SURVIVE].set_active (
                presets.get_boolean (preset_name, "survive_reboot")
            );
        set_focus ();
    }

    public Gtk.MenuItem[] get_file_menu ()
    {
        if (file_menu == null)
            build_file_menu ();
        return file_menu;
    }

    private void build_file_menu ()
    {
        file_menu = new Gtk.MenuItem[3];
        Gtk.MenuItem item;
        item = new Gtk.MenuItem.with_mnemonic (_("Save Preset - _Duration"));
        item.set_tooltip_text (
            _("Saves preset for current time delay setup.\nAll other application settings are included."));
        item.activate.connect (()=> {trigger_save_preset(Timer_Preset.DURATION);});
        file_menu[Timer_Preset.DURATION] = item;
        item = new Gtk.MenuItem.with_mnemonic (_("Save Preset - Target _Time"));
        item.set_tooltip_text (
            _("Saves preset for current target time.\nThe preset sets the timer so to expire at this time within 24 hours from current time.\nAll other application settings are included."));
        item.activate.connect (()=> {trigger_save_preset(Timer_Preset.TARGET_TIME);});
        file_menu[Timer_Preset.TARGET_TIME] = item;
        item = new Gtk.MenuItem.with_mnemonic (_("Save Preset - T_arget Time & Day"));
        item.set_tooltip_text (
            _("Saves preset for current target time and day of week.\nThe preset sets the timer so to expire at this time and day within one week from current time.\nAll other application settings are included."));
        item.activate.connect (()=> {trigger_save_preset(Timer_Preset.TARGET_TIME_DAY);});
        file_menu[Timer_Preset.TARGET_TIME_DAY] = item;
    }

    public Gtk.CheckMenuItem[] get_settings_menu ()
    {
        if (settings_menu == null)
            build_settings_menu ();
        return settings_menu;
    }

    private void build_settings_menu ()
    {
        settings_menu = new Gtk.CheckMenuItem[Timer_Settings.SETTINGS_COUNT];

        settings_menu[Timer_Settings.SURVIVE] = new Gtk.CheckMenuItem.with_mnemonic (_("_Survive Reboot"));
        settings_menu[Timer_Settings.SURVIVE].set_tooltip_text (
            _("When active, SGTimer will automaticaly start after reboot, if incorectly terminated, and will try to continue unfinished job"));
        //settings_menu[Settings.SURVIVE].set_active (true);
        settings_menu[Timer_Settings.SURVIVE].activate.connect (()=>{
                    update_survive_launcher (settings_menu[Timer_Settings.SURVIVE].get_active());
        });
    }

    private void trigger_save_preset (int pf)
    {
        preset_format = pf;
        save_preset_trigger (null);
        preset_format = Timer_Preset.DURATION;
    }
}

enum Timer_Preset
{
    TARGET_TIME_DAY,
    TARGET_TIME,
    DURATION
}

enum Timer_Settings
{
    SURVIVE,
    SETTINGS_COUNT
}
